;  ,    .
;        .
;       2003        .
;             ,   ,
;          .
;        (,     ), 
; . ,     ,    1957.  
;  (paques 1957 1) -     ,   (paques 1957 2)- 
;  .
;   -  ,  .
; :  1582  2199 .  1582 .    ,
;   2199 .   .   ,       
; .
;         ,   
;  oldortho.
;;; 
;;;	 Prepared by : Okonechnikov A.N.                                        
;;;      	                                                                
;;;             	   Moscow                                               
;;;              	   Russia                                               
;;;-----------------------------------------------------------------------------
;;;  Last revision : 13/01/2003.                                                
;;;-----------------------------------------------------------------------------
;          ,    
; . 
;   .
; shura-alex@mtu-net.ru

(defun c:time_date
		   (/	     month_list	       dt	dat
		    cel	     year     month    seconds	minuts
		    hours    mdm
		   )
  (setq mdm (getvar "modemacro"))
  (setq dt (getvar "date"))
  (setq dat (getvar "cdate"))
  (setq cel (fix dat))
  (setq year (/ cel 10000))
  (setq month (- (/ cel 100) (* year 100)))
  (setq day (- cel (* year 10000) (* month 100)))
  (if (< day 10)
    (setq day (strcat "0" (rtos (fix day) 2 0)))
    (setq day (rtos (fix day) 2 0))
  )
  (setq month (month_n month))
  (setq seconds (* 86400.0 (- dt (fix dt))))
  (setq minuts (/ seconds 60.0))
  (setq hours (/ seconds 3600.0))
  (setq minuts (* 60.0 (- hours (fix hours))))
  (if (< hours 10)
    (setq hours (strcat "0" (rtos (fix hours) 2 0)))
    (setq hours (rtos (fix hours) 2 0))
  )
  (if (< minuts 10)
    (setq minuts (strcat "0" (rtos (fix minuts) 2 0)))
    (setq minuts (rtos (fix minuts) 2 0))
  )
  (setvar "modemacro" "")
  (while (< (- (* 86400.0 (- (getvar "date") (fix (getvar "date"))))
	       seconds
	    )
	    2
	 )
    (setvar "modemacro"
	    (strcat
	      "*  "
	      day
	      "  "
	      month
	      "  "
	      (rtos year 2 0)
	      "  "
	      hours
	      ":"
	      minuts
	      "  *"
	    )
    )
  )
  (setvar "modemacro" "")
  (setq dt (getvar "date"))
  (setq seconds (* 86400.0 (- dt (fix dt))))

  (while (< (- (* 86400.0 (- (getvar "date") (fix (getvar "date"))))
	       seconds
	    )
	    2
	 )

    (setvar "modemacro"
	    (strcat
	      "*  : "
	      (paques year 1)
	      "  *"
	    )
    )
  )
  (setvar "modemacro" "")
  (setq dt (getvar "date"))
  (setq seconds (* 86400.0 (- dt (fix dt))))
  (while (< (- (* 86400.0 (- (getvar "date") (fix (getvar "date"))))
	       seconds
	    )
	    2
	 )

    (setvar "modemacro"
	    (strcat
	      "*  : "
	      (paques year 2)
	      "  *"
	    )
    )
  )
  (setvar "modemacro" mdm)
  (princ)
)

(defun paques (y p / m n alfa b	c A d Bb e Ee gt gts delta nmon	nday Eee
	       oldortho)
  (if (= p 1)
    (setq m 15
	  n 6
    )
    (progn
      (cond
	((and (< y 1699) (> y 1582))
	 (setq m 22
	       n 2
	 )
	)
	((and (< y 1799) (>= y 1700))
	 (setq m 23
	       n 3
	 )
	)
	((and (< y 1899) (>= y 1800))
	 (setq m 23
	       n 4
	 )
	)
	((and (< y 2099) (>= y 1900))
	 (setq m 24
	       n 5
	 )
	)
	((and (< y 2199) (>= y 2100))
	 (setq m 24
	       n 6
	 )
	)
      )
    )
  )
  (setq alfa (mod y 19.0))
  (setq b (mod y 4.0))
  (setq c (mod y 7.0))
  (setq A (+ (* 19 alfa) m))
  (setq d (mod A 30.0))
  (setq Bb (+ (* 2 b) (* 4 c) (* 6 d) n))
  (setq e (mod Bb 7.0))
  (setq Ee (atoi (rtos (+ e d) 2 2)))
  (if (and (= (fix (* (- (- Ee 8.6) (fix (- Ee 8.6))) 10)) 4)
	   (>= Ee 10)
      )
    (setq gt "")
    (setq gt "")
  )
  (if (and (= (fix (* (- (+ Ee 22.3) (fix (+ Ee 22.3))) 10)) 3)
	   (< Ee 10)
      )
    (setq gt "")
    (setq gt "")
  )

  (cond
    ((= Ee 35)
     (setq oldortho "19 "
	   Eee	    19.4
     )
    )
    ((= Ee 34)
     (setq oldortho "18 "
	   Eee	    18.4
     )
    )
    ((>= Ee 10)
     (setq oldortho (strcat (rtos (fix (- Ee 8.6)) 2 2) " " gt)
	   Eee	    (- Ee 8.6)
     )
    )
    ((< Ee 10)
     (setq oldortho (strcat (rtos (fix (+ Ee 22.3)) 2 2) " " gt)
	   Eee	    (+ Ee 22.3)
     )
    )
  )
  (cond
    ((and (>= y 1582) (< y 1700)) (setq delta 10))
    ((and (>= y 1700) (< y 1800)) (setq delta 11))
    ((and (>= y 1800) (< y 1900)) (setq delta 12))
    ((and (>= y 1900) (< y 2100)) (setq delta 13))
    ((and (>= y 2100) (< y 2200)) (setq delta 14))
    ((> y 2200) (setq delta 15))
  )
  (if (and (> (+ (fix Eee) delta) 31) (= gt ""))
    (setq nmon "")
  )
  (if (and (<= (+ (fix Eee) delta) 31) (= gt ""))
    (setq nmon "")
  )
  (if (and (<= (+ (fix Eee) delta) 30) (= gt ""))
    (setq nmon "")
  )
  (if (and (> (+ (fix Eee) delta) 30) (= gt ""))
    (setq nmon "")
  )

  (if (< (+ (fix Eee) delta) 31)
    (setq nday (+ (fix Eee) delta))
    (progn
      (if (= gt "")
	(setq nday
	       (+ (- (+ (- (+ (fix Eee) delta) 30) Eee) (fix Eee)) 0.1)
	)
	(setq nday
	       (+ (- (+ (- (+ (fix Eee) delta) 31) Eee) (fix Eee)) 0.1)
	)
      )
    )
  )
  (princ)

  (if (= p 1)
    (strcat (rtos (fix nday) 2 2) "  " nmon)
    (strcat (rtos (fix Eee) 2 2)
	    "  "
	    (month_n (atoi (rtos (* (rem Eee 1) 10) 2 2)))
    )
  )
					;oldortho
)

(defun mod (f K)
  (- f (* K (fix (/ f K))))
)

(defun month_n (n / month_list)
  (setq	month_list
	 '(""	       ""	   ""   ""	   ""
	   ""       ""	   ""      ""   ""
	   ""   ""	   ""
	  )
  )
  (nth n month_list)
)
